WITH ada.strings.unbounded;
USE ada.strings.unbounded;


package scannerpak is

  --Der Typ "tokenart" enthlt alle in der while-Sprache mglichen Token. Diese sind aufsteigend
   --nach Prioritt angeordnet:
   TYPE tokenart IS 
         (ganzezahl_token,  
          bezeichner_token, 
          rop_token,        
          op_token,         
          auf_token,        
          zu_token,         
          zuw_token,        
          strichp_token,    
          if_token,         
          then_token,       
          else_token,       
          fi_token,         
          skip_token,       
          while_token,      
          do_token,         
          od_token); 

   --Die Token-Liste ist folgendermaen deklariert:
   type elem;
   type listOfToken is access elem;
   TYPE elem IS 
      RECORD 
         token  : tokenart;  
         string : unbounded_string;  
         rest   : listoftoken;  
   end record;
  
   
   FUNCTION scanner (
         w : unbounded_string ) 
      return Listoftoken;
      
   ------------------------------------------------------------------------------------------------
   -- druckelistoftoken (Zusatz)
   --
   -- Die Funktion "druckelistoftoken" dient der Veranschaulichung der Prozedur:
   ------------------------------------------------------------------------------------------------
    
   PROCEDURE druckelistoftoken (
         lot : listoftoken );

end scannerpak;

   