-- Grammatik der Klammergebirge (eindeutig, weil einfach)

with Text_IO; use Text_IO;
with GrammatikGenerator;

procedure Klammergebirge is

   type Grammatiksymbole is (S,'(',')');

   package KG_Grammatik is new GrammatikGenerator(Grammatiksymbole,1);
   use KG_Grammatik;
    
   rechteSeiten : Zeichenarray(1..4) := ('(',S,')',S);
   test1 : Wort (1..4) := ('(',')','(',')');
   test2 : Wort (1..3) := ('(',')','(');
                       
begin
     
   neueAlternativeHinzu(S, rechteSeiten(1..0)) ; 
   neueAlternativeHinzu(S, rechteSeiten) ; 
     
   druckeGrammatik; -- new_line(2); 
   
--   if hatEpsilonRegel(S) then
--      put ("S ist epsilon-Symbol");
--   end if; 
     
   new_line(2); 
   put_line("()(()) liegt wegen");
   if not wortImSprachschatz(test1) then
      put ("nicht ");
   end if;
   put("im Sprachschatz ");
     
   new_line(2); 
   put_line(")( liegt wegen");
   if not wortImSprachschatz(test2) then
      put ("nicht ");
   end if;
   put("im Sprachschatz ");
     
--   new_line(2); 
--   put_line("()( liegt wegen");
--   if not wortImSprachschatz(test3) then
--      put ("nicht ");
--   end if;
--   put("im Sprachschatz ");
     
end Klammergebirge;
