-- Das Relationenpaket ist der Kern der Aufgabe. Es stellt die fr
-- den Aufbau der Grammatik erforderlichen Mengen First und Follow
-- zur verfgung, die ihrerseits auf den Relationen Anfang, Ende,
-- und Neben arbeiten. Desweiteren bietet es dafr auch die
-- Mglichkeit alle Nicht-Terminalen einer Grammatik zu finden,
-- die Epsilon werden knnen;


-- Folgende Pakete werden verwendet
with Text_IO; USE Text_IO;
with Grammatikgenerator2;
with Toadi;
with Mengen;

-- Es wird der generische typ Z deklariert
generic
   type Z is (<>);
   
   ANt : in positive;
   

package Relationenpaket is
  
   package Paar is new Toadi(Z);
   use Paar;
   package Gg is new Grammatikgenerator2(Z,ANt);
   use Gg;
   package Menge is new Mengen(Z);
   use Menge;
   use Mat;

-- wird fuer Anfang und Ende benoetigt
   function pruefe (Zeif : Zeichenfolge; Tp : Tupelpoint;
   I : Nichtterminal ) return Tupelpoint;   

-- Gibt eine Liste aller Grammatiksymbole wieder,
--  vor denen ein Epsilon stehen kann   
   function Anfang return Tupelpoint;
      
-- Gibt eine Liste aller Grammatiksymbole wieder,
--  nach denen ein Epsilon stehen kann 
   function Ende return Tupelpoint;
      
-- Gibt eine Liste aller Grammatiksymbole wieder,
--  zwischen denen ein Epsilon stehen kann 
   function Neben return Tupelpoint;
         
-- Zaehlt die Epsilonsymbole einer Grammatik und listet diese auf
   function Epszaehler return ListZ;
      
-- Ausdruckfunktion fr den Epszaehler
   procedure Druckeeps (Erglist : ListZ);
   
-- Gibt die First Relation wieder
   function First return Tupelpoint;
      
-- Gibt die Follow Relation wieder
   function follow return Tupelpoint;
      
   private
     
       
   end Relationenpaket;
   